
#include<stdio.h>
#include<stdlib.h>

int trova_min(int *p, int* q) {
  int i_min=0;
  int i=0;
  int v_min = *p;
  for (; p<=q; p++, i++) {
    if (*p < v_min) {
      v_min = *p;
      i_min = i; 
    }    
  }
  return i_min;
}

#define N 16

void scambia(int *pa, int *pb) {
  int tmp = *pa;
  *pa = *pb;
  *pb = tmp;
}

void stampa_array(int *v, int n) {
  int i;
  for (i=0; i<n; i++) {
    printf("%d ", v[i] );
  }
  printf("\n");
}

void merge(int *v1, int *v2, int *v3, int n) {
  /* n e' la dimensione di v1 o v2 */
  
  int cur_pos=0;
    
  int i=0; int j=0;
  while (i<n && j<n) {
    if (v1[i] <= v2[j]) {
      v3[cur_pos]=v1[i];
      i++;
    }
    else {
      v3[cur_pos]=v2[j];
      j++;
    }
    cur_pos++;
  }

  if (i==n) {
    while (j<n) {
      v3[cur_pos]=v2[j];
      j++; cur_pos++;
    }
  }
  else {
    while (i<n) {
      v3[cur_pos]=v1[i];
      i++; cur_pos++;
    }
  }
}

main() {
  
  int v[N];
  
  /* definisce v random */
  srand(time(0));
  int i;
  for (i=0; i<N; i++)
    v[i] = rand()%100 - 50;
  
  //printf("Vettore Originale: ");
  //stampa_array(v,N);

  int v1[4] = {-3,-1,2,4};
  int v2[4] = {1,3,4,5};
  int v3[8];

  merge(v1,v2,v,4);
  
  stampa_array(v,8);
}
